/* LAB7RCV.C - Receive component of shared memory / semaphores pair */

#include "lab7.h"

#define WAIT_TIME   10000

main()
{
    char *pname;
    HEV hNameChange = 0;
    APIRET ulResultCode, ulErrorCode;
    ULONG ulPostCount;
    char *errormessage;

    /* *LAB* Wait until the shared segment can be successfully opened */
    /* And set the name pointer to it */


    /* *LAB* Open the name-change semaphore */

    if(ulResultCode != NO_ERROR) {
        fputs("DosOpenEventSem Failed\n", stderr);
        switch(ulResultCode) {
            case ERROR_INVALID_HANDLE: errormessage = "Error: Invalid handle";
                break;
            case ERROR_NOT_ENOUGH_MEMORY: errormessage = "Not enough memory";
                break;
            case ERROR_INVALID_PARAMETER: errormessage = "Invalid parameter";
                break;
            case ERROR_INVALID_NAME: errormessage = "Invalid name";
                break;
            case ERROR_SEM_NOT_FOUND: errormessage = "Semaphore not found";
                break;
            case ERROR_TOO_MANY_OPENS: errormessage = "Too many opens";
                break;
             default : errormessage = "Unknown error code";
                printf("%08x", ulResultCode);
                break;
        }
        fputs(errormessage, stderr);
        DosExit(EXIT_PROCESS, 1);
    }

    puts("Name receiver program");
    for(;;) {
        /* *LAB* Wait on the semaphore and check to see if it times out */

        switch(ulResultCode) {
            case ERROR_SEM_TIMEOUT:
                puts("Haven't heard a new name for over ten seconds now. . .");
                break;
            case NO_ERROR:
                fputs("I just received the name ", stdout);
                puts(pname);
                break;
            case ERROR_INVALID_HANDLE:
                puts("DosWaitEventSem: Invalid Handle");
                break;
             case ERROR_NOT_ENOUGH_MEMORY:
                puts("DosWaitEventSem: Not Enough Memory");
                break;
             case ERROR_INTERRUPT:
                puts("DosWaitEventSem: Interrupt Error");
                break;
             case ERROR_TIMEOUT:
                puts("DosWaitEventSem: Timeout");
                break;
        }
        /* *LAB* Set the semaphore to indicate that we got the name */

    }
}
