/* Lab 7 - Use of shared memory and semaphores */

#include "lab7.h"

main()
{
    char *pname;
    HEV hNameChange;
    APIRET  ulResultCode, ulErrorCode;
    ULONG   ulPostCount;

    /* *LAB* Create a semaphore to signal that something has been stored in it */
    if(DosCreateEventSem(SEMNAME,&hNameChange,DC_SEM_SHARED, FALSE) != 0) {
        fputs("DosCreateSem failed", stderr);
        ulErrorCode = 1;
    }

    /* *LAB* Allocate a shared memory segment, by the name of NAME.DAT */
    /* *LAB* And set the pname pointer to point to it */
    ulResultCode = DosAllocSharedMem((PPVOID) &pname,
                                    SEGNAME, 
                                    STRLEN,
                                    PAG_COMMIT | PAG_READ | PAG_WRITE);
    if(ulResultCode != NO_ERROR) {
        fputs("DosAllocSharedMem failed", stderr);
        ulErrorCode = 1;
    }

    /* *LAB* Set the semaphore to block the receiver */
    DosResetEventSem(hNameChange, &ulPostCount);
    puts("What's your name? ");
    while(gets(pname)) {
        /* *LAB* Clear the semaphore so the receiver echoes the name */
        DosPostEventSem(hNameChange);
        fputs("I passed your name on, ", stdout);
        puts(pname);
        fputs("I'm ready for another name, ", stdout);
        puts(pname);
    }
    puts("Goodbye\n");
    /* *LAB* Close the semaphore and release the segment */

    DosCloseEventSem(hNameChange);
    DosFreeMem((PVOID) pname);
}
